namespace Syntriax.Engine.Core;

public abstract class Behaviour2D : Behaviour, IBehaviour2D
{
    public ITransform2D Transform { get; private set; } = null!;

    protected sealed override void OnInitialize(IInitializable _)
    {
        Transform = BehaviourController.GetRequiredBehaviour<ITransform2D>();
        base.OnInitialize(_);
    }

    protected sealed override void OnFinalize(IInitializable _)
    {
        Transform = null!;
        base.OnFinalize(_);
    }

    protected sealed override void OnUnassign(IAssignable assignable) => base.OnUnassign(assignable);
    protected sealed override void PreUpdate(IBehaviourController behaviourController) => base.PreUpdate(behaviourController);
    protected sealed override void FirstActiveFrame() => base.FirstActiveFrame();
    protected sealed override void Update(IBehaviourController behaviourController) => base.Update(behaviourController);
    protected sealed override void PreDraw(IBehaviourController behaviourController) => base.PreDraw(behaviourController);
    protected sealed override void EnteredUniverse(IUniverseObject sender, IUniverse universe) => base.EnteredUniverse(sender, universe);
    protected sealed override void ExitedUniverse(IUniverseObject sender, IUniverse universe) => base.ExitedUniverse(sender, universe);
}
