namespace Syntriax.Engine.Core;

public interface IReadOnlyProgressionTracker
{
    event ProgressionUpdatedEventHandler? OnUpdated;
    event ProgressionEndedEventHandler? OnEnded;

    float Progression { get; }
    string Status { get; }

    delegate void ProgressionUpdatedEventHandler(IReadOnlyProgressionTracker sender, float previousProgression, string previousStatus);
    delegate void ProgressionEndedEventHandler(IReadOnlyProgressionTracker sender);
}
