using Syntriax.Engine.Core;

namespace Syntriax.Engine.Systems.Tween;

public static class TweenCircleExtensions
{
    public static ITween TweenCircle(this Circle initialCircle, ITweenManager tweenManager, float duration, Circle targetCircle, System.Action<Circle> setMethod)
        => tweenManager.StartTween(duration,
            t => setMethod?.InvokeSafe(
                new Circle(
                    initialCircle.Center.Lerp(targetCircle.Center, t),
                    initialCircle.Diameter.Lerp(targetCircle.Diameter, t)
                )
            )
        );
}
