using System;
using Syntriax.Engine.Core;

namespace Syntriax.Engine.Systems.Tween;

public static class TweenQuaternionExtensions
{
    public static ITween TweenQuaternion(this Quaternion initialQuaternion, ITweenManager tweenManager, float duration, Quaternion targetQuaternion, Action<Quaternion> setMethod)
       => tweenManager.StartTween(duration, t => setMethod?.InvokeSafe(initialQuaternion.SLerp(targetQuaternion, t)));
}
