using System;
using Syntriax.Engine.Core;

namespace Syntriax.Engine.Systems.Tween;

public static class TweenTriangleExtensions
{
    public static ITween TweenTriangle(this Triangle initialTriangle, ITweenManager tweenManager, float duration, Triangle targetTriangle, Action<Triangle> setMethod)
       => tweenManager.StartTween(duration,
            t => setMethod?.InvokeSafe(
                new Triangle(
                    initialTriangle.A.Lerp(targetTriangle.A, t),
                    initialTriangle.B.Lerp(targetTriangle.B, t),
                    initialTriangle.C.Lerp(targetTriangle.C, t)
                )
            )
        );
}
