using Syntriax.Engine.Core;

namespace Syntriax.Engine.Systems.Tween;

public static class TweenVector2DExtensions
{
    public static ITween TweenVector2D(this Vector2D initialVector2D, ITweenManager tweenManager, float duration, Vector2D targetVector2D, System.Action<Vector2D> setMethod)
        => tweenManager.StartTween(duration, t => setMethod?.InvokeSafe(initialVector2D.Lerp(targetVector2D, t)));
}
