using Syntriax.Engine.Core;

namespace Syntriax.Engine.Systems.Tween;

public static class TweenVector3DExtensions
{
    public static ITween TweenVector3D(this Vector3D initialVector3D, ITweenManager tweenManager, float duration, Vector3D targetVector3D, System.Action<Vector3D> setMethod)
        => tweenManager.StartTween(duration, t => setMethod?.InvokeSafe(initialVector3D.Lerp(targetVector3D, t)));
}
